"""initial

Revision ID: 63bed959b634
Revises:
Create Date: 2022-04-26 16:32:49.415909+02:00

"""
import sqlalchemy as sa
from alembic import op
from alembic_utils.pg_function import PGFunction
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "63bed959b634"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    public_setting_generate_id = PGFunction(
        schema="public",
        signature="setting_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'SET-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"setting_sid_seq\"') INTO value_numeric;\n                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )
    op.create_entity(public_setting_generate_id)
    op.create_table(
        "setting",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "id", sa.String(), server_default=sa.text("setting_generate_id()"), nullable=False
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("value", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_setting_id"), "setting", ["id"], unique=True)
    op.create_index(op.f("ix_setting_name"), "setting", ["name"], unique=False)
    op.create_index(op.f("ix_setting_sid"), "setting", ["sid"], unique=False)

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###

    op.drop_index(op.f("ix_setting_sid"), table_name="setting")
    op.drop_index(op.f("ix_setting_name"), table_name="setting")
    op.drop_index(op.f("ix_setting_id"), table_name="setting")
    op.drop_table("setting")

    public_setting_generate_id = PGFunction(
        schema="public",
        signature="setting_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'SET-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"setting_sid_seq\"') INTO value_numeric;\n                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )

    op.drop_entity(public_setting_generate_id)

    # ### end Alembic commands ###
